
#ifdef WIN32
	#include <windows.h>
	#pragma comment(lib, "Irrlicht.lib")
#endif

#include <irrlicht.h>

using namespace irr;
using namespace core;
using namespace video;
using namespace scene;
using namespace gui;

#ifndef PI
	#define PI 3.1415926536
#endif

float SCALE = 1.0f;	//gk
int   TV    = 0;	//eNX`ǂݍݍW
int   RZ    = 0;	//]
int   COL   = 0;	//J[p^[

position2d<s32> mouse;

//Cxg
class MyEventReceiver : public IEventReceiver
{
public:
	virtual bool OnEvent(const SEvent& event)
	{
		if(event.EventType == EET_MOUSE_INPUT_EVENT)
		{
			switch(event.MouseInput.Event)
			{
				case EMIE_LMOUSE_PRESSED_DOWN:
					if(TV < 3)
						TV++;
					else
						TV = 0;
					return true;
				case EMIE_MMOUSE_PRESSED_DOWN:
					COL++;
					if(COL == 8)
						COL = 0;
					return true;
				case EMIE_RMOUSE_PRESSED_DOWN:
					RZ+=30;
					if(RZ == 360)
						RZ = 0;
					return true;
				case EMIE_MOUSE_WHEEL:
					//]
					if(event.MouseInput.Wheel == 1)
					{
						if(SCALE < 10.0f)
							SCALE += 0.2f;
					}
					//]
					else if(event.MouseInput.Wheel == -1)
					{
						if(SCALE > 0.2f)
							SCALE -= 0.2f;
					}
					return true;
				case EMIE_MOUSE_MOVED:
					mouse.X = event.MouseInput.X;
					mouse.Y = event.MouseInput.Y;
					return true;
				default:
					return true;
			}
		}
		return false;
	}
};

//XvCg`
void sprite(IVideoDriver *driver, char* filename, 
			int x, int y, int w, int h, int u, int v, int r, 
			float sx, float sy, SColor color,
			bool bColorKey)
{
	matrix4 rotate, pos, Ortho, scale, world;
	SColor col = color;
	char *file = filename;

	dimension2d<s32> screen = driver->getScreenSize();

	//eNX`ǂݍ
	ITexture* Texture;
	Texture = driver->getTexture(file);
	//[]
	//F݂ԂŁAق̐Fw肷ƔĂȂ
	//`̂тɃJ[L[w肷ƒxȂi`Ƃ͕ʂ]܂j
	//At@w肷ꍇ0x80ȏゾLAȊO͓
	if(bColorKey)
	{
		//J[L[(Fw)
		driver->makeColorKeyTexture(Texture, 0x00000000);
		//J[L[(Ww)
		//driver->makeColorKeyTexture(Texture,position2d<s32>(0,0));
	}
	dimension2d<s32> tex = Texture->getOriginalSize();

	//}eAݒ
	SMaterial Material;
	Material.Lighting     = false;
	if(bColorKey)
		Material.MaterialType = EMT_TRANSPARENT_ALPHA_CHANNEL; //摜At@
	else
		Material.MaterialType = EMT_TRANSPARENT_VERTEX_ALPHA;//_At@
	Material.TextureLayer[0].Texture  = Texture;

	//gkݒ
	scale.setScale(vector3df(sx,sy,1));//Zł̊gk̓_

	//ʒuݒiɐݒj
	float px = ((x)+w/2*sx)/((double)screen.Width/2) - 1.0;
	float py = 1.0 - ((y)+h/2*sy)/((double)screen.Height/2);
	pos.setTranslation(vector3df(px,py,0));//ZWł̈ʒuw̓_

	//]ݒiSŉ]j
	float rad = (float)(PI/180);//1xݒ
	float rz = (r)%360 * rad;
	rotate.setRotationRadians(vector3df(0,0,rz));//XYWł̉]̓_

	//|S쐬
	u16 list[] = {0,1,2, 2,1,3};
	S3DVertex ver[4];
	float tx = w/2;
	float ty = h/2;
	float tw = (float)w/tex.Width;
	float th = (float)h/tex.Height;
	float tu = (float)(u)/(float)tex.Width;
	float tv = (float)(v)/(float)tex.Height;
	ver[0] = S3DVertex(-tx, ty, 0,  0,0,0, col, tu,   tv   );//
	ver[1] = S3DVertex( tx, ty, 0,  0,0,0, col, tu+tw,tv   );//E
	ver[2] = S3DVertex(-tx,-ty, 0,  0,0,0, col, tu,   tv+th);//
	ver[3] = S3DVertex( tx,-ty, 0,  0,0,0, col, tu+tw,tv+th);//E

	//XN[ݒ
	//lȊOiW,0,0,0,0,H,0,0,0,0,1,0,0,0,0,1j
	Ortho(0,0) = (double)2/(double)screen.Width;
	Ortho(1,1) = (double)2/(double)screen.Height;

	//[hɔf
	driver->setTransform(ETS_VIEW, world);
	driver->setTransform(ETS_PROJECTION, world);
	world = pos*Ortho*rotate*scale;
	driver->setTransform(ETS_WORLD, world);

	//`
	driver->setMaterial(Material);
	driver->drawIndexedTriangleList(&ver[0], 4, &list[0], 2);
}

void makeScene(IVideoDriver *driver)
{
	SColor colors[8] = 
	{
		0xFFFFFFFF, 0xFF0000FF, 0xFF00FF00, 0xFFFF0000,
		0xFF00FFFF, 0xFFFF00FF, 0xFFFFFF00, 0xFF000000
	};
	sprite(driver, "icon.bmp", mouse.X,mouse.Y,32,32,TV*32,0,
		RZ,SCALE,SCALE,colors[COL],true);
}

#ifdef WIN32
	int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR strCmdLine, int nShowCmd)
#else
	int main()
#endif
{
	MyEventReceiver Receiver;

	IrrlichtDevice *device = createDevice(EDT_OPENGL,dimension2d<s32>(320,240),16,false,false,0,&Receiver);
	IVideoDriver *driver = device->getVideoDriver();
	ISceneManager* smgr  = device->getSceneManager();

	device->setEventReceiver(&Receiver);

	device->setWindowCaption(L"Irrlicht");//EChE^Cgݒ

	//Cg
	smgr->addLightSceneNode(0, vector3df(0,0,-1000), SColorf(0xFFFFFFFF), 1000.0f);

	//Jݒ
	smgr->addCameraSceneNode(0, vector3df(0,0,-5), vector3df(0,0,0));

	while(device->run())
	{
		driver->beginScene(true,true,0xFF6060FF);

		//}`쐬
		makeScene(driver);

		//V[̕`
		smgr->drawAll();

		driver->endScene();
	}

	driver->drop();

	return 0;
}
